 #include <X11/Xlib.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #define LEFT_BORDER 400
 #define DOWN_BORDER 300
 #define x0 200
 #define y0 100


int read_KeyPress (XEvent *eventp, unsigned int *xf,unsigned int  *yf)
{
    XKeyEvent *e = (XKeyEvent *) eventp;
//    printf ("keycode %u ", a);
	switch (e->keycode) {//  Что значит -> ?
		case 111: //up
		      if ((*yf) != 0) (*yf)--;
		      break;
		case 116: //down
		      if ((*yf) != DOWN_BORDER-1) (*yf)++;
		      break;
		case 113: //left
		      if ((*xf) != 0) (*xf)--;
		      break;
		case 114: //right
		      if ((*xf) != LEFT_BORDER-1) (*xf)++;
		      break;
	}
    return 0;
}


 
int main(void) 
{
    unsigned int x=x0, y=y0;
    Display *d;
    Window w;
    unsigned int s;
    XEvent e;
                        /* open connection with the server */
   d = XOpenDisplay(NULL);
   if (d == NULL) {
     fprintf(stderr, "Cannot open display\n");
     exit(1);
   }
 
   s = DefaultScreen(d);
 
                        /* create window */
   w = XCreateSimpleWindow(d, RootWindow(d, s), 10, 10, LEFT_BORDER, DOWN_BORDER, 1,
                           BlackPixel(d, s), WhitePixel(d, s));
 
                        /* select kind of events we are interested in */
   XSelectInput(d, w, ExposureMask | KeyPressMask);
 
                        /* map (show) the window */
   XMapWindow(d, w);
 
                        /* event loop */

    while (1)
    {
        XNextEvent(d, &e);
        if (e.type == Expose)
        {
			XDrawPoint(d, w, DefaultGC(d, s), x, y);
        }    
        if (e.type == KeyPress)
        {
			XSetForeground(d, DefaultGC(d, s), 0xFFFFFF);
			XDrawPoint(d, w, DefaultGC(d, s), x, y); //закрашиваем белым то место, где была точка
		    read_KeyPress (&e, &x, &y);
		    XSetForeground(d, DefaultGC(d, s), 0x000000);
		    XDrawPoint(d, w, DefaultGC(d, s), x, y); //рисуем точку в новом или в том же места
		    //return 0;
	    }
         
    }
    return 0;
}